#include <stdlib.h>
#include <stdio.h>
#include "rand.h"


#define CHECKALLOC(a) {  \
  if ( (a)==NULL ){ \
    fprintf(stderr,"Allocation failure - file %s line %d\n",__FILE__,__LINE__); \
    exit(2); \
  } \
}

double mean(int n, double *U);
void printArray(int nx,double *x,int nd);


int main(void){
  double *X;
  int n=10000;
  
  CHECKALLOC(X=(double*) malloc(n*sizeof(double)));
  
  uniform_real_distribution(-2.,3.,n,X);
  printArray(n,X,6);
  printf("mean : %.6f\n",mean(n,X));
  
  
  free(X);
  return 0;
}

double mean(int n, double *U){
  double S=0.;
  int i;
  
  for (i=0;i<n;i++)
    S+=U[i];
  return S/n;
}

void printArray(int nx,double *x,int nd){
  int i;
  printf("<double>[%d]:\n",nx);
  if (2*nd>nx){
    for (i=0;i<nx;i++)
      printf("%.6f ",x[i]);
  }else{
    for (i=0;i<nd;i++)
      printf("%.6f ",x[i]);
    printf("\n ...\n");
    for (i=nx-nd;i<nx;i++)
      printf("%.6f ",x[i]);
    printf("\n");
  }
}
